//+------------------------------------------------------------------+
//|                                              MODIFY BY LEONID553 |
//+------------------------------------------------------------------+
#property copyright "leonid553@ya.ru"
#property link      "http://articles.mql4.com/ru/403"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Gray
#property indicator_color2 Sienna
#property indicator_color3 Black
#property indicator_color4 Gray
#property indicator_color5 Sienna
#property indicator_color6 Black
#property indicator_color7 Lime
#property indicator_color8 DodgerBlue

extern string  Symbol_1 = "FDAXH0";
extern string  Symbol_2 = "FTSEH0";
extern int N1 = 10;
extern int N2 = 10;
extern string  _________  = "===   ==="; 
extern int MA_per =  21;
extern int MA_fast = 13;
extern int ma_method=2;
extern int Price=6;

//---- buffers
double Symbol1[]; double Symbol2[];

double DrawFilling1Up[];
double DrawFilling1Dn[];
double DrawEmpty1[];
double DrawFilling2Up[];
double DrawFilling2Dn[];
double DrawEmpty2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
SetIndexStyle(0,DRAW_HISTOGRAM);SetIndexBuffer(0,DrawFilling1Up);SetIndexLabel(0,"Inner area");
SetIndexStyle(1,DRAW_HISTOGRAM);SetIndexBuffer(1,DrawFilling1Dn);SetIndexLabel(1,"Inner area");
SetIndexStyle(2,DRAW_HISTOGRAM);SetIndexBuffer(2,DrawEmpty1);SetIndexLabel(2,"Outer area"); 

SetIndexStyle(3,DRAW_HISTOGRAM);SetIndexBuffer(3,DrawFilling2Up);SetIndexLabel(3,"Inner area");
SetIndexStyle(4,DRAW_HISTOGRAM);SetIndexBuffer(4,DrawFilling2Dn);SetIndexLabel(4,"Inner area");
SetIndexStyle(5,DRAW_HISTOGRAM);SetIndexBuffer(5,DrawEmpty2);SetIndexLabel(5,"Outer area"); 

SetIndexStyle(6,DRAW_LINE);SetIndexBuffer(6,Symbol1);SetIndexLabel(6,Symbol_1); 
SetIndexStyle(7,DRAW_LINE);SetIndexBuffer(7,Symbol2);SetIndexLabel(7,Symbol_2); 
      return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()  {   return(0);  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {  //int limit;
     int counted_bars=IndicatorCounted();
  //----    
     if(counted_bars<0) return(-1);
  //----     
     if(counted_bars>0) counted_bars-=10;
     //limit=Bars-counted_bars;
  //----  
      int per1,per2;
      per1 = MA_per;   per2 = MA_fast; 
  //------------------------------------------------------------
   int limit=Bars - IndicatorCounted();  
   int k;    for(k = 0; k < limit; k++)   {  
 
       Symbol1[k]=
            (iMA(Symbol_1,Period(),per2,0,ma_method,Price,iBarShift(Symbol_1,0,Time[k],false))-
            iMA(Symbol_1,Period(),per1,0,ma_method,Price,iBarShift(Symbol_1,0,Time[k],false)))*N1  ;            
            
       Symbol2[k]=
            (iMA(Symbol_2,Period(),per2,0,ma_method,Price,iBarShift(Symbol_2,0,Time[k],false))-
            iMA(Symbol_2,Period(),per1,0,ma_method,Price,iBarShift(Symbol_2,0,Time[k],false)))*N2   ;           
      
                        }  
//=======     
string Delta  = DoubleToStr(Symbol1[0]-Symbol2[0],2);
string info = Symbol_1+"="+"."+" "+Symbol_2+"="+"."+
 " Delta="+Delta+"     " ;    IndicatorShortName(info);
//-----------------------------------------------------   

   for(k = 0; k < limit; k++)   
   {
      double v1 = Symbol1[k];
      double v2 = Symbol2[k];
      if (v1 != EMPTY_VALUE && v2 != EMPTY_VALUE)
      {
         
         if (v1 > v2)
         {
            DrawFilling1Up[k] = MathMax(0, MathMax(v1, v2));
            DrawFilling2Up[k] = MathMin(0, MathMin(v1, v2));
            DrawFilling1Dn[k] = 0;
            DrawFilling2Dn[k] = 0;
         }
         else
         {
            DrawFilling1Dn[k] = MathMax(0, MathMax(v1, v2));
            DrawFilling2Dn[k] = MathMin(0, MathMin(v1, v2));
            DrawFilling1Up[k] = 0;
            DrawFilling2Up[k] = 0;
         }

         DrawEmpty1[k] = MathMax(0, MathMin(v1, v2));
         DrawEmpty2[k] = MathMin(0, MathMax(v1, v2));
      }
   }

    return(0);
  }
//+------------------------------------------------------------------+