//+------------------------------------------------------------------+
//|      .                  |
//| Copyright  2010, Son_Of_Earth                                   |
//+------------------------------------------------------------------+
#property copyright "Son_Of_Earth"
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 LimeGreen  
#property indicator_level1 1  
#property indicator_level2 0.8  
#property indicator_level3 0.2  
#property indicator_level4 0  

extern string    Symbol1.Name="DXZ0";     //   .   ,    .
extern string    Symbol2.Name="EURGBP";   //   .
//  Symbol.Vol         EquityScale:
// --  EquityScale=true, Symbol.Vol -     - ;
// --  EquityScale=false, Symbol.Vol -    - ,
//                Lots*TickValue/TickSize;
//     ( + Buy, - Sell)
extern double    Symbol1.Vol=1;           //      1- . 
extern double    Symbol2.Vol=0.6;         //      2- .
extern bool      EquityScale = true;      //   
extern int       ChannelPeriod = 100;     //     

double Last[];
double Ind[];
int wndNum;                                //   
string wndName;                            //  
int soundCount; 
double Symbol1.K, Symbol2.K;
string sname;
bool isFirst;

string oComment="spreadParamO";            //   

//===============================================================

int init(){
  isFirst=true;
  if(Symbol1.Name=="") Symbol1.Name=Symbol();
  Symbol1.Name=StringUpper(Symbol1.Name);
  Symbol2.Name=StringUpper(Symbol2.Name);
  
  //     
  if(MarketInfo(Symbol1.Name, MODE_BID)<0.0000001) {
    Alert("Ticker "+Symbol1.Name+" not found!");
    return(1);
  }
  if(MarketInfo(Symbol2.Name, MODE_BID)<0.0000001) {
    Alert("Ticker "+Symbol2.Name+" not found!");
    return(1);
  }
  
  if(EquityScale) {
    Symbol1.K = MarketInfo(Symbol1.Name, MODE_TICKVALUE)/MarketInfo(Symbol1.Name, MODE_TICKSIZE);
    Symbol2.K = MarketInfo(Symbol2.Name, MODE_TICKVALUE)/MarketInfo(Symbol2.Name, MODE_TICKSIZE);
  }
  else {
    Symbol1.K = 1;
    Symbol2.K = 1;
  }
 
  int StartBar = Bars - MathMax(iBarShift(NULL,0,MathMax(iTime(Symbol1.Name,0,iBars(Symbol1.Name,0)-1),iTime(Symbol2.Name,0,iBars(Symbol2.Name,0)-1))),0);

  sname = DoubleToStr(Symbol1.Vol,2)+"*"+DoubleToStr(Symbol1.K,0)+"*"+Symbol1.Name;
  if(Symbol2.Vol>0)
    sname=sname+"+";
  else
    sname=sname+"-";
  sname=sname+DoubleToStr(MathAbs(Symbol2.Vol),2)+"*"+DoubleToStr(Symbol2.K,0)+"*"+Symbol2.Name;
  sname=sname+"("+ChannelPeriod+")";

  IndicatorBuffers(2);
  
  SetIndexShift(0,0);
  SetIndexBuffer(0,Ind);
  SetIndexStyle(0,DRAW_LINE);
  SetIndexLabel(0,"Last");
  SetIndexDrawBegin(0,StartBar+ChannelPeriod);
  
  SetIndexBuffer(1,Last);

  return(0);
}

//===============================================================

int deinit()  {
  //    
  DeleteObject(oComment);
  return(0);  
}

//===============================================================

int start() {
  if(isFirst) {
    wndNum=WindowFind(WindowExpertName());
    wndName=WindowExpertName()+wndNum; 
    DrawLabel(oComment, sname, 8, DarkGray, 16);
    isFirst=false;
  }
  int    counted_bars=IndicatorCounted();
  if(counted_bars<0) return(-1);
  if(counted_bars>0) counted_bars--; 
  int limit=Bars-counted_bars;

  int i;
  datetime t;

  //  
  for (i=0;i<limit;i++) {
    t=Time[i];
    Last[i] = Symbol1.Vol*Symbol1.K*iClose(Symbol1.Name,0,iBarShift(Symbol1.Name,0,t)) + 
              Symbol2.Vol*Symbol2.K*iClose(Symbol2.Name,0,iBarShift(Symbol2.Name,0,t));
  }

  //        
  double StdDev;
  for(i=0;i<limit;i++) {
    StdDev=iStdDevOnArray(Last,0,ChannelPeriod,0,MODE_SMA,i);
    if(StdDev>0.00001) //    
      Ind[i]=(Last[i]+2*StdDev-iMAOnArray(Last,0,ChannelPeriod,0,MODE_SMA,i))/(4*StdDev);
  }

}

//-----------------------------------------

//  
void DrawLabel(string aName, string aText, int aFontSize, color aColor, int aValue) {
  string objName=aName+wndName;
//  ObjectDelete(objName);
  ObjectCreate(objName, OBJ_LABEL, wndNum, 0, 0);
  ObjectSetText(objName, aText, aFontSize, "Verdana", aColor);
  ObjectSet(objName, OBJPROP_CORNER, 0);
  ObjectSet(objName, OBJPROP_XDISTANCE, 4);
  ObjectSet(objName, OBJPROP_YDISTANCE, aValue); 
}

//   
void DeleteObject(string name) {
  ObjectDelete(name+wndName);
}

string StringUpper(string s) {
  int c, i, k=StringLen(s), n;
  for (i=0; i<k; i++) {
    n=0;
    c=StringGetChar(s, i);
    if (c>96 && c<123) n=c-32;    // a-z -> A-Z
    if (c>223 && c<256) n=c-32;   // - -> -
    if (c==184) n=168;            //    ->  
    if (n>0) s=StringSetChar(s, i, n);
  }
  return(s);
}

